
#include "lowreceiver.h"
#include "messagecell_ab.h"

void LowReceiver::manage_abcast(Message * mesg) {
	static std::list<MessageCellAb *> fifo_get;
	static std::list<MessageCellAb *> fifo_send;

	std::list<MessageCellAb *>::iterator iter;
	printf("LowReceiver::manage_abcast -- init\n");

	// identifiant = horloge + id_site_emeteur
	bool iAmTheEmitter = false;
	bool firstSeenMessage = true;

	if (mesg->getStamp().getIndex() == _group.getIndex()){
		iAmTheEmitter = true;
	}

	if (iAmTheEmitter){
		printf("LowReceiver::manage_abcast - Received my own message \n");
		//on faire la gestion du abcast/send ici, c'est plus simple que
		//de partager une variable+mutex avec le sender
		
		// chercher si l'on a dja recu ce message
		MessageCellAb * cell = NULL;
		for (iter = fifo_send.begin(); iter != fifo_send.end(); iter++){
			//on fait pointer cell sur la cellule si gale a l'id du message
			//courant
			MessageCellAb * cur = *iter;
			if (cur->message == mesg){
				printf("LowReceiver::manage_abcast -- message seen\n");
				firstSeenMessage = false;
				cell = cur;
				break;
			}
		}
		if (firstSeenMessage){
			//sinon on le cre
			printf("LowReceiver::manage_abcast -- message is first\n");
			cell = new MessageCellAb();
			cell->message = new Message(*mesg); 
			//et on l'ajoute au fifo
			fifo_send.push_back(cell);
		}

		// comparer le timestamp max a ceux que l'on recoit
		cell->count += 1;
		if (cell->count == _group.getCount()){
			// broadcaster le nouveau timestamp du message
			//
			// le message a broadcaster est exactement le message max
			// reu... mais bon... on le reconstruit quand m^eme
			// IMPROVE
			
			TimeStamp st = cell->message->getStamp();
			Message * nMsg = new Message(Protocol::TYPE_ABCAST,
										st,
										cell->maximum->getRaw(),
										cell->maximum->getRawSize());
			_group.broadcast(*nMsg);
			// FIXME: dlivrer le message
		}
	} else {
		printf("LowReceiver::manage_abcast - Received a message from a friend\n");
		for (iter = fifo_get.begin(); iter != fifo_get.end(); iter++){
			MessageCellAb * cur = *iter;
			if (cur->message == mesg) {
				printf("LowReceiver::manage_abcast -- message seen\n");
				firstSeenMessage = false;
				break;
			}
		}

		if (firstSeenMessage){
			printf("LowReceiver::manage_abcast -- message is first\n");
			// si le message est vu pour la premiere fois:
			// - on l'ajoute dans la liste d'attente
			MessageCellAb * cell = new MessageCellAb();
			cell->message = new Message(*mesg);
			cell->type = MessageCellAb::TYPE_TEMPORARY;		
			// - FIXME: on retourne une estampille(reception)  a l'emeteur

		} else {
			// sinon 
			// - l'estampille du message est mise a jour
			TimeStamp * stamp = new TimeStamp (Protocol::TYPE_ABCAST, mesg->getData(), mesg->getDataSize());

			// - le message est marqu comme final
			// - on dfile les estampille finale la 
		}
	}
}


